diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/RELEASE_NOTES ns-3.31/RELEASE_NOTES
--- ns-3.30.1/RELEASE_NOTES	2019-09-18 10:41:27.000000000 -0700
+++ ns-3.31/RELEASE_NOTES	2020-06-27 17:40:01.000000000 -0700
@@ -1,30 +1,109 @@
 
 		ns-3 RELEASE NOTES
 
-This file contains ns-3 release notes (most recent releases first).  
+This file contains ns-3 release notes (most recent releases first).
 
-All of the ns-3 documentation is accessible from the ns-3 website: 
+All of the ns-3 documentation is accessible from the ns-3 website:
 http://www.nsnam.org including tutorials: http://www.nsnam.org/tutorials.html
 
 Consult the file CHANGES.html for more detailed information about changed
 API and behavior across ns-3 releases.
 
-Release 3-dev
-=============
+Release 3.31
+============
 
 Availability
 ------------
-This release is not yet available.
+This release is available from:
+https://www.nsnam.org/release/ns-allinone-3.31.tar.bz2
 
 Supported platforms
 -------------------
-To be determined.
+This release is intended to work on systems with the following minimal
+requirements (Note:  not all ns-3 features available on all systems):
+- g++-4.9 or later
+- Xcode 10.1 or later
+- Python 3.5 or later
+
+Starting with ns-3.30, Python 3 has been the only supported Python version,
+and scripts default to Python 3 usage.
+
+This release has been tested on the following systems:
+- Fedora 32 with g++-10.1.1 and Python 3.8.3
+- Fedora 32 with clang-10.0.0 and Python 3.8.3
+- Fedora 29 with g++-8.3.1 and Python 3.7.5
+- Ubuntu 20.04 with g++-9.3.0 and Python 3.8.2
+- Ubuntu 18.04 with g++-7.5.0 and Python 3.6.9
+- Ubuntu 16.04.6 with g++-5.4.0 and Python 3.5.2
+- macOS 10.15.3 (Catalina) with Xcode 11.3
+- macOS 10.13.6 (High Sierra) with Xcode 10.1
 
 New user-visible features
 -------------------------
-
-Bugs fixed
-----------
+- (antenna) Model for antenna arrays based on 3GPP model (part of Integration of the 3GPP TR 38.901 fast fading model)
+- (buildings) Random walk mobility model that does not allow nodes to enter buildings
+- (core) The CommandLine facility can now add the Usage message to the Doxygen for the program
+- (internet) TCP DCTCP model
+- (internet) An option to enable IPv4 hash-based multicast duplicate packet
+  detection (DPD) based on RFC 6621
+- (lte) Trace sources for uplink PSD and RBs
+- (propagation) 3GPP TR 38.901 pathloss and channel condition models
+- (spectrum) Matrix-based channel model base class to support antenna arrays
+- (spectrum) 3GPP pathloss, channel and fast fading models
+- (stats) A new interface to SQLite
+- (tests) Capability to run an example program as a regression test
+- (traffic-control) Support for the Cake set-associative hash to the FqCoDel queue disc
+- (traffic-control) Support for ECN marking to CoDel and FqCoDel queue discs
+- (wifi) A Bianchi (saturation) example with a comparable MATLAB model
+- (wifi) The idealized wifi rate control includes better support for different MIMO modes and channel widths
+
+Bugs fixed
+----------
+If available, the numbers below make reference to a Bugzilla bug number, GitLab 
+issue number (prefixed by '#'), or GitLab merge request number (prefixed by '!')
+- (build system) #119 - Waf --lcov-report option was broken
+- (buildings) #80 - Update indoor/outdoor status of a moving node
+- (core) Bug 2725 - EmpiricalRandomVariable should not interpolate
+- (documentation) Bug 2636 - Add to doxygen a list of all registered TypeIds
+- (internet) - Fix Ipv6Prefix length calc and add explicit prefix length constructors
+- (internet) - IPv6 Duplicate Address Detection (DAD) must use Solicited-Node multicast address
+- (internet) #111 - Rip and RipNg don't receive unicast packets
+- (internet:tcp) - call NotifyConnectionFailed on SYN timeout
+- (internet:tcp) #179 - Avoid incorrect exit of LAST-ACK state
+- (internet:tcp) #182 - Fix SACK list cleaning in TcpOptionSack::Deserialize()
+- (internet:tcp) !156 - Enable entering CA_RECOVERY despite large sequence number increase
+- (internet:tcp) !157 - Prevent sending outside receiver window
+- (lr-wpan) #212 - Rx callback must have both source mac and pan id
+- (lr-wpan) !283 - Beacon collisions and timings
+- (lr-wpan) !326 - Inactive Periods Queue fix
+- (lte) #106 - Inconsistent imsi representation in LTE module
+- (lte) #196 - Remove LteSecondaryCellSelectionTestSuite from LTE module
+- (lte) #221 - Stop T310 upon receving handover command
+- (network) #216 - Correct the return value for PacketSocket::SendTo()
+- (network) !239 - Refactor DelayJitterEstimation to more closely follow RFC 1889 and RFC 3550
+- (propagation) !269 - Fix Okumura-Hata propagation loss model for frequency > 1.5 Ghz and medium or small city
+- (wifi) - Keep the medium busy if reception is aborted ahead of scheduled time
+- (wifi) - Fix frame capture when signals arrive at the exact same time and add additional tests to verify these cases
+- (wifi) - Fix MCS selection in ideal rate manager for cases with unbalanced MIMO settings and/or RX diversity
+- (wifi) - Fix SNR computations for MIMO
+- (wifi) - Fix ReportAmpduTxStatus called two times when BAR is explicitely sent upon missed BACK
+- (wifi)  A zero value for the backoff timer might be discarded and a new value
+  might be generated by an erroneous call to NotifyCollision().
+- (wifi) Bug 1909, Issue #41 - Implementation of ACK timeout
+- (wifi) Bug 2385, Issue #178 - IdealWifiManager can pick invalid WifiTxVector under certain MIMO conditions
+- (wifi) Bug 2928 - BlockAckManager::NeedBarRetransmission returns "true" infinitely
+- (wifi) Bug 2985 - PhyTxEnd tracecallback not implemented
+- (wifi) Bug 3011, Issue #172 - MIMO error rate model is incorrect
+- (wifi) #22 - Station long retry counter is incremented twice if BlockAck was not received
+- (wifi) #40 - IdealWifiManager not working if stations are moving
+- (wifi) #84 - Wi-Fi removing wrong header due to copy-paste error
+- (wifi) #94 - Retransmitted frames not marked as retransmits
+- (wifi) #107 - Frame capture model works incorrectly if two signals arrive at the same time
+- (wifi) #110 - PCAP trace file gives unexpected results
+- (wifi) #116 - Incorrect state when receiving A-MPDU in WifiPhy
+- (wifi) #165 - Notify station manager when a BlockAck has not been received after the transmission of an A-MPDU
+- (wifi) #169 - Ideal rate manager does not work when non best-effort traffic is used
+- (wifi) #211 - Remove MSDUs with expired lifetime when (re)starting channel access
 
 Known issues
 ------------
@@ -59,10 +138,11 @@
 
 Bugs fixed
 ----------
-- Issue #62 - ICMP does not handle ICMPv4 TIME_EXCEEDED responses 
+- Issue #62 - ICMP does not handle ICMPv4 TIME_EXCEEDED responses
 - Issue #77 - Wi-Fi VHT capabilities MaxMpduLength had invalid restriction
 - Issue #79 - Wi-Fi connection drop or low throughput due to Block Ack transmit window
 - Example program tap-wifi-virtual-machine.py had a syntax error
+- Issue #80 - Indoor/outdoor status is not updated when the node moves
 
 Release 3.30
 ============
@@ -202,10 +282,10 @@
 This release is intended to work on systems with the following minimal
 requirements (Note:  not all features available on all platforms):
 - g++-4.9 or later
-- Apple LLVM version 7.0.2 or later 
+- Apple LLVM version 7.0.2 or later
 - clang-3.3 or later
 
-In addition, Python 2.7 (Python 2 series) or Python 3.4-3.7 (Python 3 series) 
+In addition, Python 2.7 (Python 2 series) or Python 3.4-3.7 (Python 3 series)
 
 This release has been tested on the following platforms:
 - Ubuntu 18.04 (64 bit) with g++-7.3.0 and Python 2.7.15
@@ -259,7 +339,7 @@
 - Bug 2931 - traffic-control: QueueDisc drops the CE marked packets
 - Bug 2936 - Disable -Wparentheses with GTK+ and gcc-8
 - Bug 2938 - build: add --disable-werror flag to Waf
-- Bug 2940 - traffic-control: QueueDisc SojournTime should be TracedCallback 
+- Bug 2940 - traffic-control: QueueDisc SojournTime should be TracedCallback
 - Bug 2941 - wifi: Order bit of Frame control field of WifiMacHeader not correctly set for some frames
 - Bug 2948 - network: SetPriority does not support value 7
 - Bug 2949 - test: Exit test.py if incorrect fullness option used
@@ -284,9 +364,9 @@
 This release is intended to work on systems with the following minimal
 compiler requirements (other compilers supporting C++11 may also work):
 - g++-4.9 or later
-- Apple LLVM version 7.0.2 or later 
+- Apple LLVM version 7.0.2 or later
 - clang-3.3 or later
-In addition, a Python 2.7 (Python 2 series) or Python 3.4 (Python 3 series) 
+In addition, a Python 2.7 (Python 2 series) or Python 3.4 (Python 3 series)
 or later is required.
 
 This release has been tested on the following platforms:
@@ -295,10 +375,10 @@
 - Fedora Core 27 (64 bit) with g++-7.3.1 and Python 2.7.14
 - Fedora Core 26 (64 bit) with g++-7.3.1 and g++-7.1.1, and Python 2.7.14
 - CentOS/RHEL 7.4 (64-bit) with g++-6.3.1 and Python 3.5.1
-  - Note: the default g++ version (4.8) must be upgraded 
+  - Note: the default g++ version (4.8) must be upgraded
 - CentOS/RHEL 6.8 (64-bit) with g++-4.9.2 and Python 2.7.13
-  - Note: the default g++ version (4.4) must be upgraded 
-  - Note: the default Python version (2.6) must be upgraded 
+  - Note: the default g++ version (4.4) must be upgraded
+  - Note: the default Python version (2.6) must be upgraded
 - OS X Sierra 10.12.6 with Xcode 9.2, Apple LLVM version 9.0.0, Python 2.7.13
 - OS X Yosemite 10.10.5 with Xcode 7.2.1, Apple LLVM vers. 7.0.2, Python 2.7.10
 
@@ -323,7 +403,7 @@
 - Bug 2107 - lte: Enable PCAP for S1 and X2 point-to-point links
 - Bug 2152 - lte: Fix uplink HARQ retx. out of synch at the MAC layer
 - Bug 2151 - lte: Generate correct redundancy version in uplink HARQ
-- Bug 2277 - lte: EpcTftClassifier::Classify blindly assumes that a packet has a L4 header 
+- Bug 2277 - lte: EpcTftClassifier::Classify blindly assumes that a packet has a L4 header
 - Bug 2505 - network:  Avoid asserts in Header/Trailer deserialization
 - Bug 2653 - tcp: Avoid saving smaller TS in case of packet reordering
 - Bug 2656 - wifi: Minstrel and MinstrelHt provide different results for 802.11a/b/g
@@ -352,7 +432,7 @@
 - Bug 2849 - lte: Received RLC and PDCP PDUs are missing in the stats files
 - Bug 2854 - wifi: Fix 802.11ax channel width capabilities
 - Bug 2856 - wifi: Correct bugs and improve logging in MinstrelHt
-- Bug 2859 - tcp: calculation of BytesInFlight during partial recovery is fixed 
+- Bug 2859 - tcp: calculation of BytesInFlight during partial recovery is fixed
 - Bug 2866 - tcp: Removed VS warnings on TcpSocketBase
 - Bug 2872 - csma: Packet copy in CsmaChannel breaks netanim tracing
 - Bug 2873 - tcp: Potential SIGFPE in TcpYeah
@@ -384,7 +464,7 @@
 This release is intended to work on systems with the following minimal
 requirements (Note:  not all features available on all platforms):
 - g++-4.9 or later (Note:  this is an upgraded requirement from ns-3.26)
-- Apple LLVM version 7.0.2 or later 
+- Apple LLVM version 7.0.2 or later
 - clang-3.3 or later
 - Python 2.7 (Python 2 series) or Python 3.4 (Python 3 series) or later
 
@@ -392,14 +472,14 @@
 - Ubuntu 17.04 (64 bit) with g++-6.3.0
 - Ubuntu 16.04 (64 bit) with g++-5.4.0
 - Ubuntu 14.04.5 (64 bit) with g++-4.9.4
-  - Note: the default g++ version (4.8) must be upgraded 
+  - Note: the default g++ version (4.8) must be upgraded
 - Fedora Core 26 (64 bit) with g++-7.1.1
 - Fedora Core 22 (64 bit) with g++-5.3.1
 - CentOS/RHEL 7.4 (64-bit) with g++-6.3.1
-  - Note: the default g++ version (4.8) must be upgraded 
+  - Note: the default g++ version (4.8) must be upgraded
 - CentOS/RHEL 6.8 (64-bit) with g++-4.9.2
-  - Note: the default g++ version (4.4) must be upgraded 
-  - Note: the default Python version (2.6) must be upgraded 
+  - Note: the default g++ version (4.4) must be upgraded
+  - Note: the default Python version (2.6) must be upgraded
 - OS X Sierra 10.12.6 with Xcode 9.0 and Apple LLVM version 9.0.0
 - OS X El Capitan 10.11.6 with Xcode 8.2.1 and Apple LLVM version 8.0.0
 - OS X Yosemite 10.10.5 with Xcode 7.2.1 and Apple LLVM version 7.0.2
@@ -439,7 +519,7 @@
 - Bug 2456 - lte: MemberCschedSapProvider and Member CschedSapProvider templates
 - Bug 2464 - spectrum: Store spectrum conversion matrix in CSR format
 - Bug 2467 - spectrum: Do not schedule StartRx for receivers on other models
-- Bug 2471 - wifi: unable to disable Block Ack agreement for 802.11n 
+- Bug 2471 - wifi: unable to disable Block Ack agreement for 802.11n
 - Bug 2477 - wifi: DCF manager assert
 - Bug 2485 - traffic-control: Check queue full before checking RED thresholds
 - Bug 2491 - wifi: replace DcfManager::MY_DEBUG
@@ -579,8 +659,8 @@
 
 New user-visible features
 -------------------------
-- (aodv) The node search radius is increased progressively (as per standard). 
-- (build system) New --check-config option to waf to reprint the summary 
+- (aodv) The node search radius is increased progressively (as per standard).
+- (build system) New --check-config option to waf to reprint the summary
   of optional features which are configured.
 - (build system) C++11 features are now supported in the codebase
 - (core) DES Metrics support; see the API docs for class DesMetrics.
@@ -591,7 +671,7 @@
   Users can use RecvFrom (for UDP) or GetPeerName (for TCP) instead.
 - (traffic control) Added the FQ-CoDel and PIE queue disc models
 - (traffic control) Introduce Byte Queue Limits (BQL)
-- (wifi) A new SpectrumWifiPhy physical layer model, making use of the 
+- (wifi) A new SpectrumWifiPhy physical layer model, making use of the
   ns-3 spectrum framework, has been introduced.  The current version of
   this model matches the API and behavior of YansWifiPhy closely, but
   over time is expected to support a different PHY abstraction and error
@@ -677,7 +757,7 @@
 - Bug 2500 - Ipv[4,6]RawSocket ignores IpTtl tag
 - Bug 2507 - ConfigStore RawTextConfigLoad doesn't reset stream error state
 - Bug 2508 - Duplicate of bug 2507
-- Bug 2514 - The maximum transmission time for VHT A-MPDUs is not correct 
+- Bug 2514 - The maximum transmission time for VHT A-MPDUs is not correct
 - No BugId - Arp logging: label with request or reply properly
 
 Known issues
@@ -710,26 +790,26 @@
 
 New user-visible features
 -------------------------
-- (internet) The native TCP implementation has been refactored, for the 
-  following improvements:  
-    1) congestion control has been aligned with the Linux architecture, 
+- (internet) The native TCP implementation has been refactored, for the
+  following improvements:
+    1) congestion control has been aligned with the Linux architecture,
        to facilitate easier coding of new congestion control algorithms
-        or porting implementations from the Linux kernel, 
-    2) Fast Retransmit and Fast Recovery algorithms, compliant to RFCs, are 
-       shared by all TCP variants, unlike previous releases. 
+        or porting implementations from the Linux kernel,
+    2) Fast Retransmit and Fast Recovery algorithms, compliant to RFCs, are
+       shared by all TCP variants, unlike previous releases.
     3) TCP Hybla and TCP HighSpeed variants have been added.
 
 - (routing) The PrintRoutingTable* functions now print the following information
-  each time they are called: 
-    1) the node ID, 
-    2) the global time, 
-    3) the local time (allowing for future introduction of per-node clocks), 
+  each time they are called:
+    1) the node ID,
+    2) the global time,
+    3) the local time (allowing for future introduction of per-node clocks),
     4) the routing protocol type
 
 - (traffic control) A traffic control sublayer has been added with the aim of
-  introducing an equivalent of the Linux Traffic +Control infrastructure into 
-  ns-3. This layer sits in between the NetDevices (L2) and the network 
-  protocol (e.g. IP). It is in charge of processing packets and performing 
+  introducing an equivalent of the Linux Traffic +Control infrastructure into
+  ns-3. This layer sits in between the NetDevices (L2) and the network
+  protocol (e.g. IP). It is in charge of processing packets and performing
   actions on them: scheduling, dropping, marking, policing, etc.  Initial
   support for flow control has been added to the PointToPointNetDevice;
   backward-compatible support for other device types is provided.
@@ -742,7 +822,7 @@
 - (wifi) A number of changes related to improving support for 802.11n/ac
   models have been introduced.
   1) Two rate controls compatible with High Throughput (HT) Wi-Fi modes
-     (e.g. 802.11n/ac), Ideal and MinstrelHT, have been added  
+     (e.g. 802.11n/ac), Ideal and MinstrelHT, have been added
   2) Support for multiple spatial streams (MIMO) using existing SISO
      error models
   3) The WiFi helper API for the WifiMac sublayer, and the configuration
@@ -751,33 +831,33 @@
 
 - (wifi) 802.11g was made backward compatible with 802.11b networks
 
-- (internet) L4 protocols (e.g., TCP, UDP, ICMP, etc.) can be demultiplexed 
-  by IP according to the incoming interface. In other words, it is now 
+- (internet) L4 protocols (e.g., TCP, UDP, ICMP, etc.) can be demultiplexed
+  by IP according to the incoming interface. In other words, it is now
   possible to use specialized L4 protocols according to the interface.
 
-- (internet) Ipv6Address::IsAllHostsMulticast() is now deprecated. 
+- (internet) Ipv6Address::IsAllHostsMulticast() is now deprecated.
   FF02::3 is not in the official reserved IPv6 multicast address list.
 
-- (internet) Ipv6Address::IsAll[Nodes,Routers]Multicast() now checks the 
-  address scope beyond the simple link-local. Nodes are checked for 
-  Interface-Local, Link-Local and Realm-Local, Routers for the above plus 
+- (internet) Ipv6Address::IsAll[Nodes,Routers]Multicast() now checks the
+  address scope beyond the simple link-local. Nodes are checked for
+  Interface-Local, Link-Local and Realm-Local, Routers for the above plus
   Site-Local.
 
-- (internet) Ipv6 routing protocols must now *not* forward packets to upper 
-  layers unless for extremey specific cases. The Ipv6L3protocol handles 
+- (internet) Ipv6 routing protocols must now *not* forward packets to upper
+  layers unless for extremey specific cases. The Ipv6L3protocol handles
   almost all the packets directed to the host.
 
-- (internet) Ipv6 can now reject packets directed to an address not configured 
+- (internet) Ipv6 can now reject packets directed to an address not configured
   on the interface they are received from (Strong End System Model, RFC 1222).
 
 - (internet) UDP and Ipv6 RAW sockets can now join Ipv6 multicast groups.
-  Incoming packets will be filtered according to if there's a socket listening 
+  Incoming packets will be filtered according to if there's a socket listening
   to that group. Source filtering is left to the application.
 
-- (network) ns-3 is now capable of serializing cooked (SLL) headers. This is 
+- (network) ns-3 is now capable of serializing cooked (SLL) headers. This is
   used in DCE to allow the generation of pcap directly readable by wireshark.
 
-- (internet) It is now possible to set custom values for RipNg Link Down 
+- (internet) It is now possible to set custom values for RipNg Link Down
   (standard is 16).
 
 - (internet) permanent (static) NDISC entries can be created for IPv6
@@ -813,7 +893,7 @@
 - Bug 2206 - Split internet-apps from applications
 - Bug 2207 - Print node ID and time when printing routing tables
 - Bug 2208 - Interface index based L4 protocols
-- Bug 2210 - set Order field to 0 for HT/VHT 
+- Bug 2210 - set Order field to 0 for HT/VHT
 - Bug 2211 - Ipv{4,6}EndPoint can cause memory corruption
 - Bug 2213 - Inconsistencies may exist between the selected WifiMacHelper and the chosen 802.11 version
 - Bug 2219 - SixLowPanNetDevice hangs trying to decode a IPv6 Fragment extension header
@@ -937,7 +1017,7 @@
 New user-visible features
 -------------------------
 - (build system) Python 3 is now supported by waf and test runner programs
-- (wifi) 802.11ac Very High Throughput (VHT) physical layer modes are now 
+- (wifi) 802.11ac Very High Throughput (VHT) physical layer modes are now
   supported.
 - (internet) permanent (static) ARP entries can be created for IPv4
 - (network) SimpleChannel allows per-NetDevice blacklists, in order to do hidden terminal testcases.
@@ -1017,11 +1097,11 @@
   CalculateBytesTxTime and CalculateBitsTxTime are to be used instead.
   The return value is a Time, instead of a double.
 - (mobility) Classes added for converting geographic to cartesian coordinates.
-- (spectrum) TvSpectrumTransmitter models added to create television 
-  transmitter(s) that transmit PSD spectrums customized by attributes such 
+- (spectrum) TvSpectrumTransmitter models added to create television
+  transmitter(s) that transmit PSD spectrums customized by attributes such
   as modulation type, power, antenna type, channel frequency, etc.
-- (wifi) Several model improvements have been made.  Access points now 
-  establish BSSBasicRateSet for control frame transmissions.  PLCP header 
+- (wifi) Several model improvements have been made.  Access points now
+  establish BSSBasicRateSet for control frame transmissions.  PLCP header
   and payload reception have been decoupled for improved PHY modeling
   accuracy.  RTS/CTS with A-MPDU is now fully supported, and 802.11n
   stations now support two-level aggregation.
@@ -1034,7 +1114,7 @@
 - Bug 2004 - Wrong timeout calculation for 802.11n in WifiMac
 - Bug 2008 - (lr-wpan) Crash if ending rx while status change is in progress
 - Bug 2025 - (lr-wpan) Changing the channel doesn't affect the Tx params
-- Bug 2034 - (lr-wpan) CSMA-CA BackoffPeriod is too short 
+- Bug 2034 - (lr-wpan) CSMA-CA BackoffPeriod is too short
 - Bug 2054 - TCP window update can shrink the Left Edge of the window
 - Bug 2066 - A-MPDU reception should check for successful preamble
 - Bug 2067 - TCP performance when advertised window exceeds sender buffer size
@@ -1079,12 +1159,12 @@
 
 New user-visible features
 -------------------------
-- (wifi) Support for MPDU aggregation has been added to the wifi model, 
+- (wifi) Support for MPDU aggregation has been added to the wifi model,
   as well as a number of related example programs.
 - (wifi) Added two combined power and rate control mechanisms to the
   wifi module.  The new mechanisms, PARF and APARF, are the first in the
-  wifi module to jointly control transmission power and data rate.  Two use 
-  case examples (PowerAdaptationDistance and PowerAdaptationInterference) 
+  wifi module to jointly control transmission power and data rate.  Two use
+  case examples (PowerAdaptationDistance and PowerAdaptationInterference)
   and a test case have also been added.
 - (lte) In previous releases of the LTE module, the bearer release
   functionality was only partially supported. As an enhancement, a
@@ -1093,18 +1173,18 @@
   LteHelper::DeActivateDedicatedEpsBearer(). The related output can be
   seen through the stats collected at different layers like PDCP, RLC,
   MAC, PHY. To support this implementation, an example and test suite is
-  added within the LTE module examples and tests folder.  
-- (wave) Additional support has been added for WiFi-based vehicular networks, 
-  including the channel-access coordination features of IEEE 1609.4 and a 
-  comprehensive VANET routing example that includes a Basic Safety 
-  Message (BSM) packet generator application and associated statistics 
-  counters.  Together, these allow users to evaluate the performance effects 
-  in a VANET of varying transmission and channel properties (e.g., packet 
-  rate, message size, transmit power, propagation loss model, impact of 
+  added within the LTE module examples and tests folder.
+- (wave) Additional support has been added for WiFi-based vehicular networks,
+  including the channel-access coordination features of IEEE 1609.4 and a
+  comprehensive VANET routing example that includes a Basic Safety
+  Message (BSM) packet generator application and associated statistics
+  counters.  Together, these allow users to evaluate the performance effects
+  in a VANET of varying transmission and channel properties (e.g., packet
+  rate, message size, transmit power, propagation loss model, impact of
   routing protocol traffic, etc.).
-- (internet) It is now possible to print the Neighbor Cache (ARP and NDISC) 
+- (internet) It is now possible to print the Neighbor Cache (ARP and NDISC)
   by using the RoutingProtocolHelper
-- (stats) A new TimeProbe class has been added to hook the data collection 
+- (stats) A new TimeProbe class has been added to hook the data collection
   framework to traced values emitting Time objects
 - (documentation) the callback function signatures for all TraceSources
   is documented in Doxygen
@@ -1150,7 +1230,7 @@
 - Bug 2037 - HT capabilities may print bogus chars
 - Bug 2038 - Stop method does not stop next wave in WaveformGenerator
 - Bug 2042 - LTE a3-rsrp-handover-algorithm.cc:  error: overflow in implicit constant conversion
-- Bug 2043 - print-introspected-doxygen crashes when some modules are disabled 
+- Bug 2043 - print-introspected-doxygen crashes when some modules are disabled
 - Bug 2044 - Buffer::Iterator::ReadNtohU16() and ReadNtohU32() not implemented correctly
 - Bug 2045 - Missing NS_OBJECT_ENSURE_REGISTERED in TcpTxBuffer and TcpRxBuffer
 - Bug 2046 - set Block Ack timeout when SetStandard is called
@@ -1191,40 +1271,40 @@
   interfaces over emulated links via the new helper class EmuEpcHelper.
 - CommandLine can now provide a shorthand argument name for any
   Attribute.
-- Implemented support for Frequency Reuse algorithms in LTE module, as the 
-  outcome of GSoC 2014 project. 
+- Implemented support for Frequency Reuse algorithms in LTE module, as the
+  outcome of GSoC 2014 project.
   The project also includes several sub-features, such as:
    - implementation of Downlink Power Control
    - implementation of Uplink Power Control
-   - new DL-CQI generation approach, which increases throughput if FR algorithms 
+   - new DL-CQI generation approach, which increases throughput if FR algorithms
      are used
-   - seven options of Frequency Reuse algorithms: LteFrNoOpAlgorithm, 
-     LteFrHardAlgorithm, LteFrStrictAlgorithm, LteFrSoftAlgorithm, 
+   - seven options of Frequency Reuse algorithms: LteFrNoOpAlgorithm,
+     LteFrHardAlgorithm, LteFrStrictAlgorithm, LteFrSoftAlgorithm,
      LteFfrSoftAlgorithm, LteFfrEnhancedAlgorithm, LteFfrDistributedAlgorithm
-   - updated RadioEnvironmentMapHelper. Now RadioEnvironmentMap can be generated 
-     for Data or Control channel and for specified RbId, what is helpful when 
+   - updated RadioEnvironmentMapHelper. Now RadioEnvironmentMap can be generated
+     for Data or Control channel and for specified RbId, what is helpful when
      using FR algorithms
 - Added a CoDel queue model.  CoDel queues measure and control the queue
-  traversal delay.  The ns-3 implementation is a port of the Linux 
+  traversal delay.  The ns-3 implementation is a port of the Linux
   implementation.
 - Added support for TCP timestamp and window scale options, and added
   ability to trace the TCP slow start threshold value.
 - SimpleNetDevice and SimpleChannel (used for adding basic link effects
-  for testing of higher-layer protocols) have been extended to support 
+  for testing of higher-layer protocols) have been extended to support
   the option of broadcast or PointToPoint link semantics.  The bandwidth
   and link delay can be constrained, and it uses an output queue.
-- SimpleNetDevice and SimpleChannel can be installed in a node through 
+- SimpleNetDevice and SimpleChannel can be installed in a node through
   a new helper: SimpleNetDeviceHelper.
 - Implemented new PacketSocketServer and PacketSocketClient applications.
-  The primary use is in tests, to avoid using the ones from the 
+  The primary use is in tests, to avoid using the ones from the
   application module that also bring in a dependency on the internet module.
-  
+
 Bugs fixed
 ----------
 
 - Bug 1673 - Config::Set/Connect does not search for attributes in parent class
 - Bug 1762 - UE stuck in IDLE_CONNECTING because RRC CONN REQ is not transmitted
-- Bug 1811 - basic traffic generator for network module 
+- Bug 1811 - basic traffic generator for network module
 - Bug 1824 - L4 protocol sockets should support BindToNetDevice over IPv6
 - Bug 1831 - TcpSocket SlowStartThreshold is not a TraceSource
 - Bug 1851 - WifiRadioEnergyModel energy consumption values are taken from a 802.15.4 chip
@@ -1278,17 +1358,17 @@
 - A new LrWpan model, providing initial support for IEEE 802.15.4 networks
 - A new IPv6 routing protocol has been added: RIPng. This protocol is
   an Interior Gateway Protocol and it is available in the Internet module.
-- A new LTE MAC downlink scheduling algorithm named Channel and QoS Aware (CQA) 
+- A new LTE MAC downlink scheduling algorithm named Channel and QoS Aware (CQA)
   Scheduler is provided by the new ``ns3::CqaFfMacScheduler`` object.
 - The Internet FlowMonitor can now track IPv6 packets.
 - FlowMonitor no longer tracks multicast/broadcast packets, reflecting
   its original design.
-- FlowMonitor "SerializeToXml" functions are now directly available 
+- FlowMonitor "SerializeToXml" functions are now directly available
   from the helper.
 - The SixLowPan model can now use uncompressed IPv6 headers. An option to
-  define the minimum compressed packet size has been added. 
+  define the minimum compressed packet size has been added.
 - Simplify output of Times in a specific unit; see Time::As ()
-- Ipv6Extension::m_dropTrace has been removed. Ipv6L3Protocol::m_dropTrace 
+- Ipv6Extension::m_dropTrace has been removed. Ipv6L3Protocol::m_dropTrace
   is now fired when appropriate.
 - IPv4 identification field value is now dependent on the protocol field.
 - Fixes to support Python >= 3.3 in ns3 Python bindings
@@ -1397,7 +1477,7 @@
 
 - A new FixedRoomPositionAllocator has been added to the buildings
   module. It allows one to generate a random position uniformly
-  distributed in the volume of a chosen room inside a chosen building.  
+  distributed in the volume of a chosen room inside a chosen building.
 
 - A new attribute ns3::LteRlcAm::TxOpportunityForRetxAlwaysBigEnough
   allows to overcome the lack for re-segmentation in the RLC AM
